#Author: Victor Slavutinsky

#Published by GPL license

import os
import bpy
import mathutils

import math
from math import radians
from math import degrees
import time

TEX_PATH=False
APPLY_MODIFIERS=True
SELECT_ONLY=True
FIRST_AXIS='X'
SECOND_AXIS='Z'
FIRST_PRIORITY='First'
WING_SURFACE=False
FIRST_OBJ=1
BACKWARDS_MOVE=0

parent=mathutils.Vector()

path_name=""
def path_extract(name_path):
	global path_name
	path_name=os.path.dirname(os.path.normpath(name_path))
	return path_name

def n_f(x):
	ret_arr=math.floor(x*10000)/10000
	return ret_arr

def find_next_first_vert(mesh, add_arr):
#as example, if vertices should go from x=0 to x=1 with each row,
#first_axis=-X,
#and in row from z=0 to z=1,
#second_axis=-Z,
#at frist it finds vertice with minimal x
#from edge which is not added yet;
#if many got same x, then one from these with minimal z
	ret_arr=[]
	ret_arr+=[-1]
	ret_arr+=[-1]
	count_edges=len(mesh.edges)
	if count_edges==0:
		return ret_arr
	first_found=0;
	xv=-1
	yv=-1
	zv=-1
	xiv=-1
	yiv=-1
	ziv=-1
	n_edge=-1
	n_vert=-1
	for i in range(count_edges):
		if (add_arr[i]==0):
			count_vert=len(mesh.edges[i].vertices)
			if first_found==0:
				xv=n_f(mesh.vertices[mesh.edges[i].vertices[0]].co[0])
				yv=n_f(mesh.vertices[mesh.edges[i].vertices[0]].co[1])
				zv=n_f(mesh.vertices[mesh.edges[i].vertices[0]].co[2])
				print("test vert {:10.4f}{:10.4f}{:10.4f}".format(xv, yv, zv))
				n_edge=i
				n_vert=0
				first_found=1
			for j in range(count_vert):
				xiv=n_f(mesh.vertices[mesh.edges[i].vertices[j]].co[0])
				yiv=n_f(mesh.vertices[mesh.edges[i].vertices[j]].co[1])
				ziv=n_f(mesh.vertices[mesh.edges[i].vertices[j]].co[2])
				equal_row=0
				if ((FIRST_AXIS=='X') and (FIRST_PRIORITY=='First')) or ((SECOND_AXIS=='X') and (FIRST_PRIORITY=='Second')):
					if xiv<xv:
						xv=xiv
						yv=yiv
						zv=ziv
						n_edge=i
						n_vert=j
					elif (((FIRST_AXIS=='X') and (FIRST_PRIORITY=='First')) or ((SECOND_AXIS=='X') and (FIRST_PRIORITY=='Second'))) and (xiv==xv):
						equal_row=1
				if ((FIRST_AXIS=='-X') and (FIRST_PRIORITY=='First')) or ((SECOND_AXIS=='-X') and (FIRST_PRIORITY=='Second')):
					if xiv>xv:
						xv=xiv
						yv=yiv
						zv=ziv
						n_edge=i
						n_vert=j
					elif (((FIRST_AXIS=='-X') and (FIRST_PRIORITY=='First')) or ((SECOND_AXIS=='-X') and (FIRST_PRIORITY=='Second'))) and (xiv==xv):
						equal_row=1
				if ((FIRST_AXIS=='Y') and (FIRST_PRIORITY=='First')) or ((SECOND_AXIS=='Y') and (FIRST_PRIORITY=='Second')):
					if yiv<yv:
						xv=xiv
						yv=yiv
						zv=ziv
						n_edge=i
						n_vert=j
					elif (((FIRST_AXIS=='Y') and (FIRST_PRIORITY=='First')) or ((SECOND_AXIS=='Y') and (FIRST_PRIORITY=='Second'))) and (yiv==yv):
						equal_row=1
				if ((FIRST_AXIS=='-Y') and (FIRST_PRIORITY=='First')) or ((SECOND_AXIS=='-Y') and (FIRST_PRIORITY=='Second')):
					if yiv>yv:
						xv=xiv
						yv=yiv
						zv=ziv
						n_edge=i
						n_vert=j
					elif (((FIRST_AXIS=='-Y') and (FIRST_PRIORITY=='First')) or ((SECOND_AXIS=='-Y') and (FIRST_PRIORITY=='Second'))) and (yiv==yv):
						equal_row=1
				if ((FIRST_AXIS=='Z') and (FIRST_PRIORITY=='First')) or ((SECOND_AXIS=='Z') and (FIRST_PRIORITY=='Second')):
					if ziv<zv:
						xv=xiv
						yv=yiv
						zv=ziv
						n_edge=i
						n_vert=j
					elif (((FIRST_AXIS=='Z') and (FIRST_PRIORITY=='First')) or ((SECOND_AXIS=='Z') and (FIRST_PRIORITY=='Second'))) and (ziv==zv):
						equal_row=1
				if ((FIRST_AXIS=='-Z') and (FIRST_PRIORITY=='First')) or ((SECOND_AXIS=='-Z') and (FIRST_PRIORITY=='Second')):
					if ziv>zv:
						xv=xiv
						yv=yiv
						zv=ziv
						n_edge=i
						n_vert=j
					elif (((FIRST_AXIS=='-Z') and (FIRST_PRIORITY=='First')) or ((SECOND_AXIS=='-Z') and (FIRST_PRIORITY=='Second'))) and (ziv==zv):
						equal_row=1
				if equal_row==1:
					if ((SECOND_AXIS=='X') and (FIRST_PRIORITY=='First')) or ((FIRST_AXIS=='X') and (FIRST_PRIORITY=='Second')):
						if xiv<xv:
							xv=xiv
							yv=yiv
							zv=ziv
							n_edge=i
							n_vert=j
					if ((SECOND_AXIS=='-X') and (FIRST_PRIORITY=='First')) or ((FIRST_AXIS=='-X') and (FIRST_PRIORITY=='Second')):
						if xiv>xv:
							xv=xiv
							yv=yiv
							zv=ziv
							n_edge=i
							n_vert=j
					if ((SECOND_AXIS=='Y') and (FIRST_PRIORITY=='First')) or ((FIRST_AXIS=='Y') and (FIRST_PRIORITY=='Second')):
						if yiv<yv:
							xv=xiv
							yv=yiv
							zv=ziv
							n_edge=i
							n_vert=j
					if ((SECOND_AXIS=='-Y') and (FIRST_PRIORITY=='First')) or ((FIRST_AXIS=='-Y') and (FIRST_PRIORITY=='Second')):
						if yiv>yv:
							xv=xiv
							yv=yiv
							zv=ziv
							n_edge=i
							n_vert=j
					if ((SECOND_AXIS=='Z') and (FIRST_PRIORITY=='First')) or ((FIRST_AXIS=='Z') and (FIRST_PRIORITY=='Second')):
						if ziv<zv:
							xv=xiv
							yv=yiv
							zv=ziv
							n_edge=i
							n_vert=j
					if ((SECOND_AXIS=='-Z') and (FIRST_PRIORITY=='First')) or ((FIRST_AXIS=='-Z') and (FIRST_PRIORITY=='Second')):
						if ziv>zv:
							xv=xiv
							yv=yiv
							zv=ziv
							n_edge=i
							n_vert=j
	if (n_edge!=-1):
		ret_arr[0]=n_edge
		ret_arr[1]=n_vert
		print("first vert {:10.4f}{:10.4f}{:10.4f}".format(mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[0], mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[1], mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[2]))
	return ret_arr

def check_cone(mesh, n_edge, n_vert):
#checks if some of faces including first vertice
#is triangle
	ret_val=0
	xv=mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[0]
	yv=mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[1]
	zv=mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[2]
	if n_vert==1:
		n_op_vert=0
	else:
		n_op_vert=1
	xov=mesh.vertices[mesh.edges[n_edge].vertices[n_op_vert]].co[0]
	yov=mesh.vertices[mesh.edges[n_edge].vertices[n_op_vert]].co[1]
	zov=mesh.vertices[mesh.edges[n_edge].vertices[n_op_vert]].co[2]
	count_polygons=len(mesh.polygons)
	if count_polygons==0:
		return ret_val
	for i in range(count_polygons):
		count_vert=len(mesh.polygons[i].vertices)
		if (count_vert==0):
			break
		xv_found=0
		xov_found=0
		for j in range(count_vert):
			if (mesh.vertices[mesh.polygons[i].vertices[j]].co[0]==xv) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[1]==yv) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[2]==zv):
				xv_found=1
			if (mesh.vertices[mesh.polygons[i].vertices[j]].co[0]==xov) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[1]==yov) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[2]==zov):
				xov_found=1
		if ((xv_found==1) and (xov_found==1) and (count_vert==3)):
			ret_val=1;
	#if (ret_val==1):
		#print("cone with {:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}".format(xv, yv, zv, xov, yov, zov))
	return ret_val

def same_poly(mesh, n_edge, n_op_edge):
#checks if two edges shares same polygone
	ret_val=0
	count_polygons=len(mesh.polygons)
	if (count_polygons==0):
		return ret_val
	v=[]
	v.append([])
	v[0].append(mesh.vertices[mesh.edges[n_edge].vertices[0]].co[0])
	v[0].append(mesh.vertices[mesh.edges[n_edge].vertices[0]].co[1])
	v[0].append(mesh.vertices[mesh.edges[n_edge].vertices[0]].co[2])
	#print("b11 {:10.4f}{:10.4f}{:10.4f}".format(v[0][0], v[0][1], v[0][2]))
	v.append([])
	v[1].append(mesh.vertices[mesh.edges[n_edge].vertices[1]].co[0])
	v[1].append(mesh.vertices[mesh.edges[n_edge].vertices[1]].co[1])
	v[1].append(mesh.vertices[mesh.edges[n_edge].vertices[1]].co[2])
	#print("b12 {:10.4f}{:10.4f}{:10.4f}".format(v[1][0], v[1][1], v[1][2]))
	v.append([])
	v[2].append(mesh.vertices[mesh.edges[n_op_edge].vertices[0]].co[0])
	v[2].append(mesh.vertices[mesh.edges[n_op_edge].vertices[0]].co[1])
	v[2].append(mesh.vertices[mesh.edges[n_op_edge].vertices[0]].co[2])
	#print("b21 {:10.4f}{:10.4f}{:10.4f}".format(v[2][0], v[2][1], v[2][2]))
	v.append([])
	v[3].append(mesh.vertices[mesh.edges[n_op_edge].vertices[1]].co[0])
	v[3].append(mesh.vertices[mesh.edges[n_op_edge].vertices[1]].co[1])
	v[3].append(mesh.vertices[mesh.edges[n_op_edge].vertices[1]].co[2])
	#print("b22 {:10.4f}{:10.4f}{:10.4f}".format(v[3][0], v[3][1], v[3][2]))
	for i in range(count_polygons):
		n_overlaps=0
		count_vert=len(mesh.polygons[i].vertices)
		if (count_vert==0):
			break
		for j in range(count_vert):
			#print("t{:d}{:d} {:10.4f}{:10.4f}{:10.4f}".format(i, j, mesh.vertices[mesh.polygons[i].vertices[j]].co[0], mesh.vertices[mesh.polygons[i].vertices[j]].co[1], mesh.vertices[mesh.polygons[i].vertices[j]].co[2]))
			if (j<(count_vert-1)):
				if ((mesh.vertices[mesh.polygons[i].vertices[j]].co[0]==v[0][0]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[1]==v[0][1]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[2]==v[0][2]) and (mesh.vertices[mesh.polygons[i].vertices[(j+1)]].co[0]==v[1][0]) and (mesh.vertices[mesh.polygons[i].vertices[(j+1)]].co[1]==v[1][1]) and (mesh.vertices[mesh.polygons[i].vertices[(j+1)]].co[2]==v[1][2])):
					#print("overlap b11-b12 {:d}{:d}-{:d}{:d}".format(i, j, i, (j+1)))
					n_overlaps=n_overlaps+1
				if ((mesh.vertices[mesh.polygons[i].vertices[j]].co[0]==v[1][0]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[1]==v[1][1]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[2]==v[1][2]) and (mesh.vertices[mesh.polygons[i].vertices[(j+1)]].co[0]==v[0][0]) and (mesh.vertices[mesh.polygons[i].vertices[(j+1)]].co[1]==v[0][1]) and (mesh.vertices[mesh.polygons[i].vertices[(j+1)]].co[2]==v[0][2])):
					#print("overlap b12-b11 {:d}{:d}-{:d}{:d}".format(i, j, i, (j+1)))
					n_overlaps=n_overlaps+1
				if ((mesh.vertices[mesh.polygons[i].vertices[j]].co[0]==v[2][0]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[1]==v[2][1]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[2]==v[2][2]) and (mesh.vertices[mesh.polygons[i].vertices[(j+1)]].co[0]==v[3][0]) and (mesh.vertices[mesh.polygons[i].vertices[(j+1)]].co[1]==v[3][1]) and (mesh.vertices[mesh.polygons[i].vertices[(j+1)]].co[2]==v[3][2])):
					#print("overlap b21-b22 {:d}{:d}-{:d}{:d}".format(i, j, i, (j+1)))
					n_overlaps=n_overlaps+1
				if ((mesh.vertices[mesh.polygons[i].vertices[j]].co[0]==v[3][0]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[1]==v[3][1]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[2]==v[3][2]) and (mesh.vertices[mesh.polygons[i].vertices[(j+1)]].co[0]==v[2][0]) and (mesh.vertices[mesh.polygons[i].vertices[(j+1)]].co[1]==v[2][1]) and (mesh.vertices[mesh.polygons[i].vertices[(j+1)]].co[2]==v[2][2])):
					#print("overlap b22-b21 {:d}{:d}-{:d}{:d}".format(i, j, i, (j+1)))
					n_overlaps=n_overlaps+1
			else:
				if ((mesh.vertices[mesh.polygons[i].vertices[j]].co[0]==v[0][0]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[1]==v[0][1]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[2]==v[0][2]) and (mesh.vertices[mesh.polygons[i].vertices[0]].co[0]==v[1][0]) and (mesh.vertices[mesh.polygons[i].vertices[0]].co[1]==v[1][1]) and (mesh.vertices[mesh.polygons[i].vertices[0]].co[2]==v[1][2])):
					#print("overlap b11-b12 {:d}{:d}-{:d}{:d}".format(i, j, i, 0))
					n_overlaps=n_overlaps+1
				if ((mesh.vertices[mesh.polygons[i].vertices[j]].co[0]==v[1][0]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[1]==v[1][1]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[2]==v[1][2]) and (mesh.vertices[mesh.polygons[i].vertices[0]].co[0]==v[0][0]) and (mesh.vertices[mesh.polygons[i].vertices[0]].co[1]==v[0][1]) and (mesh.vertices[mesh.polygons[i].vertices[0]].co[2]==v[0][2])):
					#print("overlap b12-b11 {:d}{:d}-{:d}{:d}".format(i, j, i, 0))
					n_overlaps=n_overlaps+1
				if ((mesh.vertices[mesh.polygons[i].vertices[j]].co[0]==v[2][0]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[1]==v[2][1]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[2]==v[2][2]) and (mesh.vertices[mesh.polygons[i].vertices[0]].co[0]==v[3][0]) and (mesh.vertices[mesh.polygons[i].vertices[0]].co[1]==v[3][1]) and (mesh.vertices[mesh.polygons[i].vertices[0]].co[2]==v[3][2])):
					#print("overlap b21-b22 {:d}{:d}-{:d}{:d}".format(i, j, i, 0))
					n_overlaps=n_overlaps+1
				if ((mesh.vertices[mesh.polygons[i].vertices[j]].co[0]==v[3][0]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[1]==v[3][1]) and (mesh.vertices[mesh.polygons[i].vertices[j]].co[2]==v[3][2]) and (mesh.vertices[mesh.polygons[i].vertices[0]].co[0]==v[2][0]) and (mesh.vertices[mesh.polygons[i].vertices[0]].co[1]==v[2][1]) and (mesh.vertices[mesh.polygons[i].vertices[0]].co[2]==v[2][2])):
					#print("overlap b22-b21 {:d}{:d}-{:d}{:d}".format(i, j, i, 0))
					n_overlaps=n_overlaps+1
		#print("overlaps: {:d}".format(n_overlaps))
		if (n_overlaps==2):
			#print("same poly")
			ret_val=1
	return ret_val

def find_next_edge(mesh, add_arr, n_edge, n_vert, first):
#as example, if vertices should go from x=0 to x=1 with each row,
#and in row from z=0 to z=1,
#if finds edge which is not used yet,
#having first one as one of vertices,
# and other one with angle minimally different with previous one,
# not of same polygone, but then finding first edge that last rule is ignored
	#print("searching for edge from vert {:10.4f}{:10.4f}{:10.4f}".format(mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[0], mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[1], mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[2]))
	ret_arr=[]
	ret_arr+=[-1]
	ret_arr+=[-1]
	count_edges=len(mesh.edges)
	if count_edges==0:
		return ret_arr
	in_cone=check_cone(mesh, n_edge, n_vert)
	delta_angle=2*math.pi
	for i in range(count_edges):
		if add_arr[i]==0:
			count_vert=len(mesh.edges[i].vertices)
			for j in range(count_vert):
				if (mesh.vertices[mesh.edges[i].vertices[j]].co[0]==mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[0]) and (mesh.vertices[mesh.edges[i].vertices[j]].co[1]==mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[1]) and (mesh.vertices[mesh.edges[i].vertices[j]].co[2]==mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[2]):
					if j==1:
						j_op_vert=0
					else:
						j_op_vert=1
					#print("checking edge {:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}".format(mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[0], mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[1], mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[2], mesh.vertices[mesh.edges[n_edge].vertices[j_op_vert]].co[0], mesh.vertices[mesh.edges[n_edge].vertices[j_op_vert]].co[1], mesh.vertices[mesh.edges[n_edge].vertices[j_op_vert]].co[2]))
					if FIRST_AXIS=='X':
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[0]-mesh.vertices[mesh.edges[i].vertices[j]].co[0];
					if FIRST_AXIS=='-X':
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j]].co[0]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[0];
					if FIRST_AXIS=='Y':
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[1]-mesh.vertices[mesh.edges[i].vertices[j]].co[1];
					if FIRST_AXIS=='-Y':
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j]].co[1]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[1];
					if FIRST_AXIS=='Z':
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[2]-mesh.vertices[mesh.edges[i].vertices[j]].co[2];
					if FIRST_AXIS=='-Z':
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j]].co[2]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[2];
					if SECOND_AXIS=='X':
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[0]-mesh.vertices[mesh.edges[i].vertices[j]].co[0];
					if SECOND_AXIS=='-X':
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j]].co[0]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[0];
					if SECOND_AXIS=='Y':
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[1]-mesh.vertices[mesh.edges[i].vertices[j]].co[1];
					if SECOND_AXIS=='-Y':
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j]].co[1]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[1];
					if SECOND_AXIS=='Z':
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[2]-mesh.vertices[mesh.edges[i].vertices[j]].co[2];
					if SECOND_AXIS=='-Z':
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j]].co[2]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[2];
					if WING_SURFACE==1:
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j]].co[0]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[0];
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j]].co[2]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[2];
						#print("new delta i {:10.4f} j {:10.4f}".format(new_delta_i, new_delta_j))
					new_delta_angle=math.atan2(new_delta_j, new_delta_i)
					#print("new delta {:10.4f}".format(new_delta_angle))
					if ((delta_angle>new_delta_angle) and (new_delta_i>0)):
						neib=same_poly(mesh, n_edge, i)
						#print("neibours {:d}".format(neib))
						if ((neib==0) or (first==1)):
							out_cone=check_cone(mesh, i, j)
							#print("in cone out cone {:d} {:d}".format(in_cone, out_cone))
							if ((first==1) or (not ((in_cone==1) and (out_cone==1)))):
								n_edge=i
								n_vert=j
								n_op_vert=j_op_vert
								delta_angle=new_delta_angle
								ret_arr[0]=n_edge
								ret_arr[1]=n_vert
	if (ret_arr[0]==-1):
		print("next edge not found")
	else:
		print("next edge {:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}".format(mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[0], mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[1], mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[2], mesh.vertices[mesh.edges[n_edge].vertices[n_op_vert]].co[0], mesh.vertices[mesh.edges[n_edge].vertices[n_op_vert]].co[1], mesh.vertices[mesh.edges[n_edge].vertices[n_op_vert]].co[2]))
	return ret_arr

def find_back_edge(mesh, add_arr, n_edge, n_vert, first):
	ret_arr=[]
	ret_arr+=[-1]
	ret_arr+=[-1]
	count_edges=len(mesh.edges)
	if count_edges==0:
		return ret_arr
	in_cone=check_cone(mesh, n_edge, n_vert)
	delta_angle=2*math.pi
	for i in range(count_edges):
		if add_arr[i]==0:
			count_vert=len(mesh.edges[i].vertices)
			for j in range(count_vert):
				if (mesh.vertices[mesh.edges[i].vertices[j]].co[0]==mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[0]) and (mesh.vertices[mesh.edges[i].vertices[j]].co[1]==mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[1]) and (mesh.vertices[mesh.edges[i].vertices[j]].co[2]==mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[2]):
					if j==1:
						j_op_vert=0
					else:
						j_op_vert=1
					#print("checking edge {:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}".format(mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[0], mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[1], mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[2], mesh.vertices[mesh.edges[n_edge].vertices[j_op_vert]].co[0], mesh.vertices[mesh.edges[n_edge].vertices[j_op_vert]].co[1], mesh.vertices[mesh.edges[n_edge].vertices[j_op_vert]].co[2]))
					if FIRST_AXIS=='-X':
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[0]-mesh.vertices[mesh.edges[i].vertices[j]].co[0];
					if FIRST_AXIS=='X':
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j]].co[0]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[0];
					if FIRST_AXIS=='-Y':
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[1]-mesh.vertices[mesh.edges[i].vertices[j]].co[1];
					if FIRST_AXIS=='Y':
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j]].co[1]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[1];
					if FIRST_AXIS=='-Z':
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[2]-mesh.vertices[mesh.edges[i].vertices[j]].co[2];
					if FIRST_AXIS=='Z':
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j]].co[2]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[2];
					if SECOND_AXIS=='X':
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[0]-mesh.vertices[mesh.edges[i].vertices[j]].co[0];
					if SECOND_AXIS=='-X':
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j]].co[0]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[0];
					if SECOND_AXIS=='Y':
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[1]-mesh.vertices[mesh.edges[i].vertices[j]].co[1];
					if SECOND_AXIS=='-Y':
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j]].co[1]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[1];
					if SECOND_AXIS=='Z':
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[2]-mesh.vertices[mesh.edges[i].vertices[j]].co[2];
					if SECOND_AXIS=='-Z':
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j]].co[2]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[2];
					if WING_SURFACE==1:
						new_delta_i=mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[0]-mesh.vertices[mesh.edges[i].vertices[j]].co[0];
						new_delta_j=mesh.vertices[mesh.edges[i].vertices[j]].co[2]-mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[2];
						#print("new delta i {:10.4f} j {:10.4f}".format(new_delta_i, new_delta_j))
					new_delta_angle=math.atan2(new_delta_j, new_delta_i)
					#print("new delta {:10.4f}".format(new_delta_angle))
					if ((delta_angle>new_delta_angle) and (new_delta_i>0)):
						#print("new delta {:10.4f}".format(new_delta_angle))
						neib=same_poly(mesh, n_edge, i)
						#print("neibours {:d}".format(neib))
						if ((neib==0) or (first==1)):
							out_cone=check_cone(mesh, i, j)
							#print("in cone out cone {:d} {:d}".format(in_cone, out_cone))
							if ((first==1) or (not ((in_cone==1) and (out_cone==1)))):
								n_edge=i
								n_vert=j
								n_op_vert=j_op_vert
								delta_angle=new_delta_angle
								ret_arr[0]=n_edge
								ret_arr[1]=n_vert
	if (ret_arr[0]==-1):
		print("next back edge not found")
	else:
		print("next back edge {:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}".format(mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[0], mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[1], mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[2], mesh.vertices[mesh.edges[n_edge].vertices[n_op_vert]].co[0], mesh.vertices[mesh.edges[n_edge].vertices[n_op_vert]].co[1], mesh.vertices[mesh.edges[n_edge].vertices[n_op_vert]].co[2]))
	return ret_arr

def find_exc_edge(mesh, add_arr, n_edge, n_vert):
#find exceeded perpendicular egde 
	ret_arr=[]
	ret_arr+=[-1]
	ret_arr+=[-1]
	count_edges=len(mesh.edges)
	if count_edges==0:
		return ret_val
	delta_angle=2*math.pi
	for i in range(count_edges):
		if add_arr[i]==0:
			count_vert=len(mesh.edges[i].vertices)
			for j in range(count_vert):
				if (mesh.vertices[mesh.edges[i].vertices[j]].co[0]==mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[0]) and (mesh.vertices[mesh.edges[i].vertices[j]].co[1]==mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[1]) and (mesh.vertices[mesh.edges[i].vertices[j]].co[2]==mesh.vertices[mesh.edges[n_edge].vertices[n_vert]].co[2]) and same_poly(mesh, n_edge, i):
					n_edge=i
					n_vert=j
					ret_val=n_edge
					if j==1:
						j_op_vert=0
					else:
						j_op_vert=1
					ret_arr[0]=n_edge
					ret_arr[1]=j_op_vert
					break
			if ret_arr[0]!=-1:
					break
	#if (ret_arr[0]==-1):
		#print("side edge not found")
	#else
		#print("side edge {:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}".format(mesh.vertices[mesh.edges[i].vertices[j]].co[0], mesh.vertices[mesh.edges[i].vertices[j]].co[1], mesh.vertices[mesh.edges[i].vertices[j]].co[2], mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[0], mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[1], mesh.vertices[mesh.edges[i].vertices[j_op_vert]].co[2]))
	return ret_arr

def create_add_test_arr(mesh):
	ret_arr=[]
	count_edges=len(mesh.edges)
	if count_edges==0:
		return ret_arr
	for i in range(count_edges):
		ret_arr+=[0]
	return ret_arr

def set_checked(mesh, add_arr, n_edge):
	xv=mesh.vertices[mesh.edges[n_edge].vertices[0]].co[0]
	yv=mesh.vertices[mesh.edges[n_edge].vertices[0]].co[1]
	zv=mesh.vertices[mesh.edges[n_edge].vertices[0]].co[2]
	xov=mesh.vertices[mesh.edges[n_edge].vertices[1]].co[0]
	yov=mesh.vertices[mesh.edges[n_edge].vertices[1]].co[1]
	zov=mesh.vertices[mesh.edges[n_edge].vertices[1]].co[2]
	add_arr[n_edge]=1
	#print("edge set checked {:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}".format(xv, yv, zv, xov, yov, zov))
	return

def add_next_edge(mesh, add_arr, n_edge, n_vert, first, output_array, next_first_vert):
	global BACKWARDS_MOVE
	edge=[]
	edge+=[-1]
	edge+=[-1]
	if (WING_SURFACE==0) or ((WING_SURFACE==1) and (BACKWARDS_MOVE==0)):
		edge=find_next_edge(mesh, add_arr, n_edge, n_vert, first)
	if (edge[0]==-1) and (WING_SURFACE==1) and (BACKWARDS_MOVE==0):
		BACKWARDS_MOVE=1;
	if (BACKWARDS_MOVE==1):
		edge=find_back_edge(mesh, add_arr, n_edge, n_vert, first)
	#new edge is found
	if (edge[0]!=-1):
		if (edge[1]==0):
			n_op_vert=1
		else:
			n_op_vert=0
		if (first==1):
			output_array.append([])
			n_row=len(output_array)-1
			output_array[n_row].append([])
			n_col=len(output_array[n_row])-1
			output_array[n_row][n_col].append(mesh.vertices[mesh.edges[edge[0]].vertices[edge[1]]].co[0])
			output_array[n_row][n_col].append(mesh.vertices[mesh.edges[edge[0]].vertices[edge[1]]].co[1])
			output_array[n_row][n_col].append(mesh.vertices[mesh.edges[edge[0]].vertices[edge[1]]].co[2])
			n_row=len(output_array)-1
			n_col=len(output_array[n_row])-1
			#print("rows: {:d}".format(n_row))
			#print("colums: {:d}".format(n_col))
		n_row=len(output_array)-1
		output_array[n_row].append([])
		n_col=len(output_array[n_row])-1
		output_array[n_row][n_col].append(mesh.vertices[mesh.edges[edge[0]].vertices[n_op_vert]].co[0])
		output_array[n_row][n_col].append(mesh.vertices[mesh.edges[edge[0]].vertices[n_op_vert]].co[1])
		output_array[n_row][n_col].append(mesh.vertices[mesh.edges[edge[0]].vertices[n_op_vert]].co[2])
		n_row=len(output_array)-1
		n_col=len(output_array[n_row])-1
		#print("rows: {:d}".format(n_row))
		#print("colums: {:d}".format(n_col))
		#set edge as checked
		set_checked(mesh, add_arr, edge[0])
		#set exceeding edges as checked
		if (first==0):
			exc_edge=find_exc_edge(mesh, add_arr, edge[0], edge[1])
			if (exc_edge[0]!=-1):
				set_checked(mesh, add_arr, exc_edge[0])
		else:
			in_cone=check_cone(mesh, edge[0], edge[1])
			if (in_cone==0):
				exc_edge=find_exc_edge(mesh, add_arr, edge[0], edge[1])
				next_first_vert[0]=exc_edge[0]
				next_first_vert[1]=exc_edge[1]
				print("planned next first vert {:10.4f}{:10.4f}{:10.4f}".format(mesh.vertices[mesh.edges[next_first_vert[0]].vertices[next_first_vert[1]]].co[0], mesh.vertices[mesh.edges[next_first_vert[0]].vertices[next_first_vert[1]]].co[1], mesh.vertices[mesh.edges[next_first_vert[0]].vertices[next_first_vert[1]]].co[2]))
				if (exc_edge[0]!=-1):
					set_checked(mesh, add_arr, exc_edge[0])
		#set vertex from which search for next edge
		edge[1]=n_op_vert
	#new edge is not found
	if (edge[0]==-1):
		out_cone=check_cone(mesh, n_edge, n_vert)
		if (out_cone==0):
			exc_edge=find_exc_edge(mesh, add_arr, n_edge, n_vert)
			if (exc_edge[0]!=-1):
				set_checked(mesh, add_arr, exc_edge[0])
	return edge

def f_i_s(x):
	s="{:d}.".format(x)
	s="{:<3s}".format(s)
	return s

def write_object(f, context, obj):
	global FIRST_OBJ, BACKWARDS_MOVE
	if obj.type=='MESH':
		print("Calculating object {:s}\n".format(obj.name))
		mesh=obj.to_mesh(context.scene, APPLY_MODIFIERS, 'PREVIEW')
		count_vert=len(mesh.vertices)
		for i in range(count_vert):
			mesh.vertices[i].co=obj.matrix_world*mesh.vertices[i].co
		output_array=[]
		next_first_vert=[]
		next_first_vert+=[-1]
		next_first_vert+=[-1]
		add_arr=create_add_test_arr(mesh)
		BACKWARDS_MOVE=0
		first_vert=find_next_first_vert(mesh, add_arr)
		while (first_vert[0]!=-1):
			edge=add_next_edge(mesh, add_arr, first_vert[0], first_vert[1], 1, output_array, next_first_vert)
			while (edge[0]!=-1):
				edge=add_next_edge(mesh, add_arr, edge[0], edge[1], 0, output_array, next_first_vert)
			BACKWARDS_MOVE=0
			if (check_cone(mesh, first_vert[0], first_vert[1])==0):
				first_vert[0]=next_first_vert[0]
				first_vert[1]=next_first_vert[1]
				if (next_first_vert[0]!=-1):
					print("")
					print("next first vert {:10.4f}{:10.4f}{:10.4f}".format(mesh.vertices[mesh.edges[first_vert[0]].vertices[first_vert[1]]].co[0], mesh.vertices[mesh.edges[first_vert[0]].vertices[first_vert[1]]].co[1], mesh.vertices[mesh.edges[first_vert[0]].vertices[first_vert[1]]].co[2]))
			else:
				first_vert=find_next_first_vert(mesh, add_arr)
		count_row=len(output_array)
		count_col=len(output_array[0])
		if (FIRST_OBJ==1):
			f.write("=nm       nn                                                          netname\n")
		f.write("{:s}       {:s}                                                         {:s}\n".format(f_i_s(count_col), f_i_s(count_row), obj.name))
		if (FIRST_OBJ==1):
			f.write("=x(1,1)   y(1,1)    z(1,1)    x(*,*)    y(*,*)    z(*,*)\n")
			FIRST_OBJ=0
		for i in range(count_row):
			one_two=0
			for j in range(count_col):
				if (one_two==0):
					one_two=1
					if (j<=(count_col-2)):
						f.write("{:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}{:10.4f}\n".format(output_array[i][j][0], output_array[i][j][1], output_array[i][j][2], output_array[i][j+1][0], output_array[i][j+1][1], output_array[i][j+1][2]))
					else:
						f.write("{:10.4f}{:10.4f}{:10.4f}\n".format(output_array[i][j][0], output_array[i][j][1], output_array[i][j][2]))
				else:
					one_two=0
	return

def test_inheritance(list_objects, obj, parent_name):
	if (obj.parent!=None):
		if (obj.parent.name==parent_name):
			return True
	elif (parent_name=='world'):
		return True
	return False

def count_children(list_objects, parent_name):
	count=0
	for obj in list_objects:
		if (obj.parent!=None):
			if (obj.parent.name==parent_name):
				count=count+1
			elif (parent_name=='world'):
				count=count+1
	return count

def write_recusively(f, context, list_objects, obj):
	write_object(f, context, obj)
	count=count_children(list_objects, obj.name)
	if (count!=0):
		for new_obj in list_objects:
			if test_inheritance(list_objects, new_obj, parent_name):
				write_recusively(f, context, list_objects, new_obj)
	return

def write_inp_file(context, filename, select_only, first_axis, second_axis, first_priority, wing_surface):
	global SELECT_ONLY, FIRST_AXIS, SECOND_AXIS, FIRST_PRIORITY, WING_SURFACE, FIRST_OBJ
	SELECT_ONLY=select_only
	FIRST_AXIS=first_axis
	SECOND_AXIS=second_axis
	FIRST_PRIORITY=first_priority
	WING_SURFACE=wing_surface
	FIRST_OBJ=1
	path_extract(filename)
	f=open(filename, 'w')
	if SELECT_ONLY:
		list_objects=context.selected_objects
	else:
		list_objects=context.scene.objects
	dic_obj_meshs={}
	for obj in list_objects:
		if obj.type=='MESH':
			dic_obj_meshs[obj.name]=obj
	list_objects_sort=[]
	for name in sorted(dic_obj_meshs.keys()):
		list_objects_sort.append(dic_obj_meshs[name])
	for obj in list_objects_sort:
		if test_inheritance(list_objects, obj, 'world'):
			write_recusively(f, context, list_objects, obj)
	f.close()
	return
