#Author: Slavutinsky Victor

#Published by GPL license

import os
import sys
import fileinput
import math
from math import radians
from math import degrees
import subprocess
from subprocess import *
import time
import re

phi_arr=[]
mach_arr=[]

mach_arr+=[0.3]
mach_arr+=[0.4]
mach_arr+=[0.5]
mach_arr+=[0.9]
mach_arr+=[1.1]
mach_arr+=[1.5]
mach_arr+=[2.0]

#phi_arr+=[-40.]
#phi_arr+=[-36.]
#phi_arr+=[-32.]
#phi_arr+=[-28.]
#phi_arr+=[-24.]
phi_arr+=[-20.]
phi_arr+=[-16.]
phi_arr+=[-12.]
phi_arr+=[-8.]
phi_arr+=[-4.]
phi_arr+=[0]
phi_arr+=[4.]
phi_arr+=[8.]
#phi_arr+=[12.]
#phi_arr+=[16.]
#phi_arr+=[20.]
#phi_arr+=[24.]
#phi_arr+=[28.]
#phi_arr+=[32.]
#phi_arr+=[36.]
#phi_arr+=[40.]

#phi_arr+=[0.]
#phi_arr+=[5.]
#phi_arr+=[10.]
#phi_arr+=[15.]
#phi_arr+=[20.]
#phi_arr+=[25.]

#phi_arr+=[-20.0]
#phi_arr+=[-15.0]
#phi_arr+=[-10.0]
#phi_arr+=[-5.0]
#phi_arr+=[0.]
#phi_arr+=[5.]
#phi_arr+=[10.]
#phi_arr+=[15.]
#phi_arr+=[20.]

res_arr=[]

path_name=""
panair_name=""
panair_out_name=""
file_with_path_name=""

def path_extract(name_path):
	global path_name
	path_name=os.path.dirname(os.path.normpath(name_path))
	return path_name

def run_panair():
	global path_name
	global panair_name
	global file_with_path_name
	for dump_file_name in os.listdir(path_name):
		if "rwms" in dump_file_name: 
			os.remove("{:s}/{:s}".format(path_name, dump_file_name))
	p = Popen([panair_name], shell=True, stdin=PIPE, stdout=PIPE, stderr=PIPE)
	p.stdin.write("{:s}".format(file_with_path_name))
	p.stdin.close()
	p.wait()
	return

def prepare_input(filename, phi, mach):
	next_string_mach=False
	next_string_phi=False
	for line in fileinput.input(filename, inplace=True):
		if (next_string_mach):
			line="{:.2f}".format(mach)
			next_string_mach=False
		if (next_string_phi):
			line="{:.2f}".format(phi)
			next_string_phi=False
		if ("=amach" in line):
			next_string_mach=True
		if ("=phi" in line):
			next_string_phi=True
		print(line.strip("\n"))
	fileinput.close()
	return

def parse_output(filename):
	res_string=""
	numeric_const_pattern = r"""
		[-+]?
		(?:
			(?: \d* \. \d+ )
			|
			(?: \d+ \.? ) # 1. 12. 123. etc 1 12 123 etc
		)
		(?: [Ee] [+-]? \d+ ) ?
	"""
	rx = re.compile(numeric_const_pattern, re.VERBOSE)
	output_found=False
	n_line=0
	for line in fileinput.input(filename):
		if (output_found):
			n_line=n_line+1
		if ((output_found) and (n_line==11)):
			re_data=rx.findall(line)
			for i in range(len(re_data)):
				res_string="{:s}\t{:s}".format(res_string, re_data[i])
		if ((output_found) and (n_line==12)):
			re_data=rx.findall(line)
			for i in range(len(re_data)):
				res_string="{:s}\t{:s}".format(res_string, re_data[i]) 
		if ((output_found) and (n_line==14)):
			re_data=rx.findall(line)
			for i in range(len(re_data)):
				res_string="{:s}\t{:s}".format(res_string, re_data[i]) 
		if ("full configuration forces and moments summary" in line):
			output_found=True
	fileinput.close()
	return res_string

def write_final_output(filename):
	global res_arr
	f=open(filename, 'w')
	count_res=len(res_arr)
	tit_str="phi\tmach\tsol\talpha\tbeta\tcl\tcdi\tcy\tfx\tfy\tfz\tmx\tmy\tmz\tarea\ttre_cl\tre_cdi\ttre_eff\n"
	f.write(tit_str)
	for i in range(count_res):
		f.write("{:s}\n".format(res_arr[i]))
	f.close()
	return

def cyclical_run():
	global phi_arr
	global mach_arr
	global res_arr
	global path_name
	global panair_name
	global panair_out_name
	global file_with_path_name
	tit_str="phi\tmach\tsol\talpha\tbeta\tcl\tcdi\tcy\tfx\tfy\tfz\tmx\tmy\tmz\tarea\ttre_cl\tre_cdi\ttre_eff"
	file_with_path_name=sys.argv[1]
	path_extract(file_with_path_name)
	panair_name="{:s}/panair".format(path_name)
	panair_out_name="{:s}/panair.out".format(path_name)
	result_out_name="{:s}.out".format(os.path.splitext(file_with_path_name)[0])
	print("panair call {:s}".format(panair_name))
	print("calculating file {:s}".format(file_with_path_name))
	os.chdir(path_name)
	print(tit_str)
	count_phis=len(phi_arr)
	count_machs=len(mach_arr)
	for i in range(count_machs):
		for j in range(count_phis):
			prepare_input(file_with_path_name, phi_arr[j], mach_arr[i])
			run_panair()
			s_res=parse_output(panair_out_name)
			s_res="{:.2f}\t{:.2f}{:s}".format(phi_arr[j], mach_arr[i], s_res)
			res_arr+=[s_res]
			print(s_res)
	print("witing final output to {:s}".format(result_out_name))
	write_final_output(result_out_name)
	return

cyclical_run()
